using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_DictionaryValue
    /// </summary>
    public partial class T_Sys_DictionaryValue
    {
        public T_Sys_DictionaryValue()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ValueId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_DictionaryValue");
            strSql.Append(" where F_ValueId=@F_ValueId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ValueId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ValueId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_DictionaryValue model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_DictionaryValue(");
            strSql.Append("F_ItemId,F_Value,F_PrentId,F_Layer,F_IsLeaf,F_Remark,F_State,F_CreateUser,F_CreateDate)");
            strSql.Append(" values (");
            strSql.Append("@F_ItemId,@F_Value,@F_PrentId,@F_Layer,@F_IsLeaf,@F_Remark,@F_State,@F_CreateUser,@F_CreateDate)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ItemId", SqlDbType.Int,4),
                    new SqlParameter("@F_Value", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_PrentId", SqlDbType.Int,4),
                    new SqlParameter("@F_Layer", SqlDbType.Int,4),
                    new SqlParameter("@F_IsLeaf", SqlDbType.Bit,1),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateDate", SqlDbType.DateTime)};
            parameters[0].Value = model.F_ItemId;
            parameters[1].Value = model.F_Value;
            parameters[2].Value = model.F_PrentId;
            parameters[3].Value = model.F_Layer;
            parameters[4].Value = model.F_IsLeaf;
            parameters[5].Value = model.F_Remark;
            parameters[6].Value = model.F_State;
            parameters[7].Value = model.F_CreateUser;
            parameters[8].Value = model.F_CreateDate;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_DictionaryValue model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_DictionaryValue set ");
            strSql.Append("F_ItemId=@F_ItemId,");
            strSql.Append("F_Value=@F_Value,");
            strSql.Append("F_PrentId=@F_PrentId,");
            strSql.Append("F_Layer=@F_Layer,");
            strSql.Append("F_IsLeaf=@F_IsLeaf,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_CreateUser=@F_CreateUser,");
            strSql.Append("F_CreateDate=@F_CreateDate");
            strSql.Append(" where F_ValueId=@F_ValueId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ItemId", SqlDbType.Int,4),
                    new SqlParameter("@F_Value", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_PrentId", SqlDbType.Int,4),
                    new SqlParameter("@F_Layer", SqlDbType.Int,4),
                    new SqlParameter("@F_IsLeaf", SqlDbType.Bit,1),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateDate", SqlDbType.DateTime),
                    new SqlParameter("@F_ValueId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_ItemId;
            parameters[1].Value = model.F_Value;
            parameters[2].Value = model.F_PrentId;
            parameters[3].Value = model.F_Layer;
            parameters[4].Value = model.F_IsLeaf;
            parameters[5].Value = model.F_Remark;
            parameters[6].Value = model.F_State;
            parameters[7].Value = model.F_CreateUser;
            parameters[8].Value = model.F_CreateDate;
            parameters[9].Value = model.F_ValueId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ValueId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_DictionaryValue ");
            strSql.Append(" where F_ValueId=@F_ValueId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ValueId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ValueId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_ValueIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_DictionaryValue ");
            strSql.Append(" where F_ValueId in (" + F_ValueIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        public bool DeleteList1(string F_ValueIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_DictionaryValue set F_State=1 ");
            strSql.Append(" where F_ValueId in (" + F_ValueIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_DictionaryValue GetModel(int F_ValueId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ValueId,F_ItemId,F_Value,F_PrentId,F_Layer,F_IsLeaf,F_Remark,F_State,F_CreateUser,F_CreateDate from T_Sys_DictionaryValue ");
            strSql.Append(" where F_ValueId=@F_ValueId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ValueId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ValueId;

            CallCenterApi.Model.T_Sys_DictionaryValue model = new CallCenterApi.Model.T_Sys_DictionaryValue();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_DictionaryValue DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Sys_DictionaryValue model = new CallCenterApi.Model.T_Sys_DictionaryValue();
            if (row != null)
            {
                if (row["F_ValueId"] != null && row["F_ValueId"].ToString() != "")
                {
                    model.F_ValueId = int.Parse(row["F_ValueId"].ToString());
                }
                if (row["F_ItemId"] != null && row["F_ItemId"].ToString() != "")
                {
                    model.F_ItemId = int.Parse(row["F_ItemId"].ToString());
                }
                if (row["F_Value"] != null)
                {
                    model.F_Value = row["F_Value"].ToString();
                }
                if (row["F_PrentId"] != null && row["F_PrentId"].ToString() != "")
                {
                    model.F_PrentId = int.Parse(row["F_PrentId"].ToString());
                }
                if (row["F_Layer"] != null && row["F_Layer"].ToString() != "")
                {
                    model.F_Layer = int.Parse(row["F_Layer"].ToString());
                }
                if (row["F_IsLeaf"] != null && row["F_IsLeaf"].ToString() != "")
                {
                    if ((row["F_IsLeaf"].ToString() == "1") || (row["F_IsLeaf"].ToString().ToLower() == "true"))
                    {
                        model.F_IsLeaf = true;
                    }
                    else
                    {
                        model.F_IsLeaf = false;
                    }
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_CreateUser"] != null)
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
                if (row["F_CreateDate"] != null && row["F_CreateDate"].ToString() != "")
                {
                    model.F_CreateDate = DateTime.Parse(row["F_CreateDate"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ValueId,F_ItemId,F_Value,F_PrentId,F_Layer,F_IsLeaf,F_Remark,F_State,F_CreateUser,F_CreateDate ");
            strSql.Append(" FROM T_Sys_DictionaryValue ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ValueId,F_ItemId,F_Value,F_PrentId,F_Layer,F_IsLeaf,F_Remark,F_State,F_CreateUser,F_CreateDate ");
            strSql.Append(" FROM T_Sys_DictionaryValue ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_DictionaryValue ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ValueId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_DictionaryValue T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Sys_DictionaryValue";
			parameters[1].Value = "F_ValueId";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

